#include "wx/wxprec.h"

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif

#include <locale.h>
#include <ctype.h>
#include "post.h"

Post::Post(wxString* file)
{
	m_file = file;
//	printf("%s\n",file->GetData());
}

wxString Post::fontdef[] = {
                "Times-Roman",		
                "Times-Bold",
                "Times-Italic",
                "Times-BoldItalic",
                "AvantGarde-Book",
                "AvantGarde-BookOblique",
                "AvantGarde-Demi",
                "AvantGarde-DemiOblique",
                "Bookman-Light",
                "Bookman-LightItalic",
                "Bookman-Demi",
                "Bookman-DemiItalic",
                "Courier",
                "Courier-Oblique",
                "Courier-Bold",
                "Courier-BoldOblique",
                "Helvetica",
                "Helvetica-Oblique",
                "Helvetica-Bold",
                "Helvetica-BoldOblique",
                "Helvetica-Narrow",
                "Helevetica-Narrow-Oblique",
                "Helevetica-Narrow-Bold",
                "Helevetica-Narrow-BoldOblique",
                "NewCenturySchlbk-Roman",
                "NewCenturyschlbk-Italic",
                "NewCenturySchlbk-Bold",
                "NewCenturySchlbk-BoldItalic",
                "Palatino-Roman",
                "Palatino-Italic",
                "Palatino-Bold",
                "Palatino-BoldItalic",
                "Symbol",
                "ZapfChancery-MediumItalic",
                "ZapfDingbats",
                "" 
};

bool Post::CreateFromMyPanel(MyPanel* panel)
{
	wxFile* fd = new wxFile(m_file->GetData(),wxFile::write);
	m_label_nb = 0;
	fd->Write("%!PS-Adobe-3.0\n");
	fd->Write("%%DocumentData: Clean7Bit\n");
	fd->Write("%%Orientation: Portrait\n");
	fd->Write("%%Pages: 1\n");
	fd->Write("%%PageOrder: Ascend\n");	
	fd->Write("%%Title: ");
	fd->Write(*m_file);
	fd->Write("\n%%EndComments\n");
	Prolog(fd);
	fd->Write("%%Page: 1 1\n");
	fd->Write("%%BeginPageSetup\n");
	fd->Write("/pagelevel save def\n");
//	fd->Write("54 0 translate\n");
	fd->Write("%%EndPageSetup\n");
	PostLabel* la = panel->m_paper + panel->m_paper_type->GetSelection();
/*
	printf("jjj %f %f %f %f %s\n",la->w,la->h,la->l_x,la->l_y,
		panel->m_paper[panel->m_paper_type->GetSelection()].name.GetData());
*/
	int i,ii;
	for (i=0;i<la->nb_row;i++){
		for(ii=0;ii<la->nb_col;ii++) {
			Paint(fd, panel,
				ii * (la->l_w + la->l_x) + la->m_l,
				la->h - (i * (la->l_h + la->l_y) + la->m_u),
				la->l_w,la->l_h);
		}
	}

	fd->Write("pagelevel restore\n");
	fd->Write("showpage\n");
	fd->Write("%%EOF\n");
        fd->Close();

        return(TRUE);
}

// print everything needed in a single label
void Post::Paint(wxFile* fd,MyPanel* panel, double x, double y, double l_w,
	double l_h)
{
	wxString str,str1,txt,txt1,form;
	wxLocale locale;
	locale.Init("english", "us","C");
	str.Printf("0.001 setlinewidth\n%.3f %.3f moveto\n%.3f %.3f lineto\n"
		"%.3f %.3f lineto\n%.3f %.3f lineto\n"
		"%.3f %.3f lineto\nstroke\n",
                        x,y, 
			x + l_w,y,
			x + l_w,y - l_h,
			x, y - l_h,
			x,y);
        fd->Write(str);

	int f=0;
	double off = 0;
	// insert the picture
	if (!panel->m_bit_txt->GetValue().IsEmpty()){
		fd->Write(str);
		wxFile* eps = new wxFile(
			panel->m_bit_txt->GetValue().GetData(),wxFile::read);
		char buf[2048];
		// find the bounding box size of the picture	
		eps->Read(buf,2048);
		buf[2047] = '\0';
		char* pos = strstr(buf,"BoundingBox:");
		char* pos1 = pos;
		long size[5];
		int cpt=0;
		while (*pos)
		{
			if (*pos == ' ' || *pos == '\n') {
				*pos = '\0';
				size[cpt] = strtol(pos1,NULL,10);	
				pos1 = pos + 1;
				cpt++;
				if (cpt >5) {*pos1 = '\0';}
			}
			pos++;
		}
		// position the picture
		double xx,yy;
		switch (panel->m_bit_align->GetSelection())
		{
			case 0:
				xx=0;
				yy=size[4]/4;
				break;
			case 3:
				xx=(l_w/2 - size[3]/8);
				yy=size[4]/4;
				break;
			case 6:
				xx=(l_w  - size[3]/4);
				yy=size[4]/4;
				break;
			case 1:
				xx=0;
				yy=(l_h/2 + size[4]/8);
				break;
			case 7:
				xx=(l_w  - size[3]/4);
				yy=(l_h/2 + size[4]/8);
				break;
			case 4:
				xx=(l_w/2 - size[3]/8);
				yy=(l_h/2 + size[4]/8);
				break;
			case 2:
				xx=0;
				yy=l_h;
				break;
			case 5:
				xx=(l_w/2 - size[3]/8);
				yy=l_h ;
				break;
			case 8:
				xx=(l_w  - size[3]/4);
				yy=l_h ;
				break;
			default:
				xx=0;
				yy=0;
		}	
			
		str.Printf("BeginEPSF\n%.2f %.2f translate\n0.25 0.25 scale\n"
			"",
			x+xx,y-yy-1);
		fd->Write(str);
		// read the picture
		eps->Seek(0,wxFromStart);
		long si,i;
		while ((si = eps->Read(buf,2048))) 
		{
			for (i=0;i<si;i++) 
			{
				if (buf[i] == '%') 
				{
					fd->Write(buf,i+1);
					eps->Seek(-(si-(i+1)),wxFromCurrent);
					// remove %%Trailer
					si = eps->Read(buf,1024);
					i=0;
					if (buf[0] == '%' && buf[1] == 'T' &&
					    buf[2] == 'r' && buf[3] == 'a' )
					{
						eps->Seek(-(si-8),
							wxFromCurrent);
						si = eps->Read(buf,1024);
					}
				}
			}
			fd->Write(buf,si);
		}
		eps->Close();
		str.Printf("\nEndEPSF\n");
		fd->Write(str);
	}	
	// loop for each line of text in the label
	for(int i=0;i<10;i++) 
	{
		txt = panel->m_txt[i]->GetValue();
		//print a big line if needed
		if (i == 5 && panel->m_bit_ligne->GetValue()) 
		{
			y -= 2;
			str.Printf("4 setlinewidth\n%.2f %.2f mv\n"
				"%.2f %.2f lineto\nstroke\n",
				x+5,y,x+l_w-5,y);
                	fd->Write(str);
			y -= 2;
		}
		double h = strtod(panel->m_txt_size[i]->GetValue().GetData(),
				NULL);
		int ii=0;
		f = -1;
		// find the right font to use
		while(!fontdef[ii].IsEmpty()) 
		{
			if (fontdef[ii].IsSameAs( 
				panel->m_txt_font[i]->GetStringSelection())) 
			{
				f = ii;
			}
			ii++;
		}
		// add upper offset of the font
		y -= (3*h/4);
                form.Printf("%%0" "%dd",
                        strlen(panel->m_nb_from->GetValue().GetData()));
                txt1.Printf(form.GetData() ,m_label_nb +
                        atol(panel->m_nb_from->GetValue().GetData()));
                txt.Replace("<<number>>",txt1,TRUE);

		// text alignement 	
		if (panel->m_txt_align[i]->GetSelection() == 1) 
		{
			str1.Printf("cshow");
			off = l_w / 2;
			if (f == -1) {
				CreateBar(fd,(char*) txt.GetData(),
					x+l_w/2-(13*h/40)*strlen(txt.GetData()),
					y,h);
			}
		} else if (panel->m_txt_align[i]->GetSelection() == 2) 
		{
			str1.Printf("rshow");
			off = l_w;
			if (f == -1) {
				CreateBar(fd,(char*) txt.GetData(),
					x+l_w-(13*h/20)*strlen(txt.GetData()),
					y,h);
			}
				
		} else 
		{
			str1.Printf("show");
			off = 0;
			if (f == -1) {
				CreateBar(fd,
				(char*)	txt.GetData(),
					x,y,h);
			}
		}
	    if (f != -1) {
		// underlined text ?
		if (0) 
		{
			str1 << "u\n";
		} else 
		{
			str1 << "\n";
		}

		// special char
		txt.Replace("\\","\\\\",TRUE);
		txt.Replace("(","\\(",TRUE);
		txt.Replace(")","\\)",TRUE);
		txt.Replace("<<registered>>","\256",TRUE);
		txt.Replace("<<copyright>>" ,"\251",TRUE);
		txt1 = "";
		// transform for a clean 7bits file !!!
		for ( char *p = (char*)txt.GetData(); *p; p++ ) 
		{
			if ((unsigned char) *p > (unsigned char)126 || 
				(unsigned char) *p < (unsigned char)32) 
			{
				txt1 += "\\";
				txt1 += (char) ((*p & 0300)>>6)+48 ;	
				txt1 += (char) ((*p & 0070)>>3)+48 ;
				txt1 += (char) (*p & 0007)+48 ;
			} else 
			{
				txt1 += *p;
			}
				
		}
		// print the text at the right place
		str.Printf("%.2f %.2f mv\n%.1f f%d\n(%s) ",
			x+off, y, h,
			f, txt1.GetData());
		if(!panel->m_txt[i]->GetValue().IsEmpty()) {
			fd->Write(str);
			fd->Write(str1);
		}
	   }
		// add lower offset of the font
		y -= (h/4);
	}
	m_label_nb++;
}

void Post::Prolog(wxFile* fd)
{
	fd->Write("%%BeginProlog\n");
	fd->Write("[ /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef\n");
	fd->Write(" /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef\n");
	fd->Write(" /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef\n");
	fd->Write(" /.notdef /.notdef /space /exclam /quotedbl /numbersign /dollar /percent /ampersand /quoteright\n");
	fd->Write(" /parenleft /parenright /asterisk /plus /comma /hyphen /period /slash /zero /one\n");
	fd->Write(" /two /three /four /five /six /seven /eight /nine /colon /semicolon\n");
	fd->Write(" /less /equal /greater /question /at /A /B /C /D /E\n");
	fd->Write(" /F /G /H /I /J /K /L /M /N /O\n");
	fd->Write(" /P /Q /R /S /T /U /V /W /X /Y\n");
	fd->Write(" /Z /bracketleft /backslash /bracketright /asciicircum /underscore /quoteleft /a /b /c\n");
	fd->Write(" /d /e /f /g /h /i /j /k /l /m\n");
	fd->Write(" /n /o /p /q /r /s /t /u /v /w\n");
	fd->Write(" /x /y /z /braceleft /bar /braceright /asciitilde /.notdef /.notdef /.notdef\n");
	fd->Write(" /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef\n");
	fd->Write(" /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef\n");
	fd->Write(" /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef /.notdef\n");
	fd->Write(" /space /exclamdown /cent /sterling /currency /yen /brokenbar /section /dieresis /copyright\n");
	fd->Write(" /ordfeminine /guillemotleft /logicalnot /hyphen /registered /macron /degree /plusminus /twosuperior /threesuperior\n");
	fd->Write(" /acute /mu /paragraph /periodcentered /cedilla /onesuperior /ordmasculine /guillemotright /onequarter /onehalf\n");
	fd->Write(" /threequarters /questiondown /Agrave /Aacute /Acircumflex /Atilde /Adieresis /Aring /AE /Ccedilla\n");
	fd->Write(" /Egrave /Eacute /Ecircumflex /Edieresis /Igrave /Iacute /Icircumflex /Idieresis /Eth /Ntilde\n");
	fd->Write(" /Ograve /Oacute /Ocircumflex /Otilde /Odieresis /multiply /Oslash /Ugrave /Uacute /Ucircumflex\n");
	fd->Write(" /Udieresis /Yacute /Thorn /germandbls /agrave /aacute /acircumflex /atilde /adieresis /aring\n");
	fd->Write(" /ae /ccedilla /egrave /eacute /ecircumflex /edieresis /igrave /iacute /icircumflex /idieresis\n");
	fd->Write(" /eth /ntilde /ograve /oacute /ocircumflex /otilde /odieresis /divide /oslash /ugrave\n");
	fd->Write(" /uacute /ucircumflex /udieresis /yacute /thorn /ydieresis] /isolatin1encoding exch def\n");
	fd->Write("/c { matrix currentmatrix currentpoint translate\n");
	fd->Write("     3 1 roll scale newpath 0 0 1 0 360 arc setmatrix } bind def\n");
	int i = 0;
	wxString str;
	while(!fontdef[i].IsEmpty()) {
		str.Printf("%d",i);	
		fd->Write(PrologFont(str,fontdef[i]));
		i++;
	};
	fd->Write("/rhc {\n    {\n");
	fd->Write("        currentfile read {\n");
	fd->Write("            dup 97 ge\n");
	fd->Write("                { 87 sub true exit }\n");
	fd->Write("                { dup 48 ge { 48 sub true exit } { pop } ifelse }\n");
	fd->Write("            ifelse\n");
	fd->Write("        } {\n");
	fd->Write("            false\n");
	fd->Write("            exit\n");
	fd->Write("        } ifelse\n");
	fd->Write("    } loop\n");
	fd->Write("} bind def\n");
	fd->Write("/cvgray { % xtra_char npix cvgray - (string npix long)\n");
	fd->Write("    dup string\n    0\n    {\n");
	fd->Write("        rhc { cvr 4.784 mul } { exit } ifelse\n");
	fd->Write("        rhc { cvr 9.392 mul } { exit } ifelse\n");
	fd->Write("        rhc { cvr 1.824 mul } { exit } ifelse\n");
	fd->Write("        add add cvi 3 copy put pop\n");
	fd->Write("        1 add\n");
	fd->Write("        dup 3 index ge { exit } if\n");
	fd->Write("    } loop\n    pop\n");
	fd->Write("    3 -1 roll 0 ne { rhc { pop } if } if\n");
	fd->Write("    exch pop\n");
	fd->Write("} bind def\n");
	fd->Write("/smartimage12rgb { % w h b [matrix] smartimage12rgb -\n");
	fd->Write("    /colorimage where {\n");
	fd->Write("        pop\n");
	fd->Write("        { currentfile rowdata readhexstring pop }\n");
	fd->Write("        false 3\n");
	fd->Write("        colorimage\n");
	fd->Write("    } {\n");
	fd->Write("        exch pop 8 exch\n");
	fd->Write("        3 index 12 mul 8 mod 0 ne { 1 } { 0 } ifelse\n");
	fd->Write("        4 index\n");
	fd->Write("        6 2 roll\n");
	fd->Write("        { 2 copy cvgray }\n");
	fd->Write("        image\n");
	fd->Write("        pop pop\n");
	fd->Write("    } ifelse\n");
	fd->Write("} def\n");
	fd->Write("/cshow { dup stringwidth pop 2 div neg 0 rmoveto show } bind def\n");
	fd->Write("/rshow { dup stringwidth pop neg 0 rmoveto show } bind def\n");
	fd->Write("/cshowu { dup stringwidth pop dup 2 div neg 0 rmoveto ");
	fd->Write("exch show neg 0 rlineto stroke } bind def\n");
	fd->Write("/rshowu { dup stringwidth pop dup neg 0 rmoveto ");
	fd->Write("exch show neg 0 rlineto stroke } bind def\n");
	fd->Write("/showu { dup stringwidth pop exch show neg 0 rlineto ");
	fd->Write("stroke } bind def\n");

	fd->Write("/mv { moveto } bind def\n");	
	fd->Write("/slw { setlinewidth } bind def\n");
	fd->Write("/rls { rlineto stroke } bind def\n");

	fd->Write("/BeginEPSF {\n");
	fd->Write("  /b4_Inc_state save def\n");
	fd->Write("  /dict_count countdictstack def\n");
	fd->Write("  /op_count count 1 sub def\n");
	fd->Write("  userdict begin\n");
	fd->Write("  /showpage {} def\n");
	fd->Write("  0 setgray 0 setlinecap 1 setlinewidth 0 setlinejoin\n");
	fd->Write("  10 setmiterlimit [] 0 setdash newpath\n");
	fd->Write("  /languagelevel where\n");
	fd->Write("  { pop languagelevel 1 ne\n");
	fd->Write("    { false setstrokeadjust false setoverprint } if\n");
	fd->Write("  } if\n");
	fd->Write("} bind def\n");	
	fd->Write("/EndEPSF {\n");
	fd->Write("  count op_count sub {pop} repeat\n");
	fd->Write("  countdictstack dict_count sub {end} repeat\n");
	fd->Write("  b4_Inc_state restore\n");
	fd->Write("} bind def\n");
	fd->Write("%%EndProlog\n");
}

wxString Post::PrologFont(wxString nb, wxString name)
{
	wxString str;
	str = "/F";
	str += nb;
	str += "\n    /";
	str += name;
	str += " findfont\n    dup length dict begin\n";
	str += "        {1 index /FID ne {def} {pop pop} ifelse} forall\n";
	str += "        /Encoding isolatin1encoding def\n";
	str += "    currentdict end\n";
	str += "definefont pop\n";
	str += "/f";
	str += nb;
	str += " {dup 20 div setlinewidth /F";
	str += nb;
	str += " findfont exch scalefont setfont } bind def\n";
	return((wxString &)str);
}
/****************************************************************************

	This function is a part of the XBarcode software.
*/
/****************************************************************************
Willkommen zu XBarcode 2.0
==========================

Dieses Programm leistet deutlich mehr als es kostet.
Wer diese Meinung nicht mit uns teilt, dem erstatten wir
selbstverstaendlich sein Geld zurueck. (nichts, da FREEWARE :-)

Mit XBarcoder koennen Sie alle gaengigen Strichcodes generieren
und als Grafikdatei abspeichern.

Verfuegbare Barcodes:                  Verfuegbare Grafikformate

   * EAN13, EAN8                          * PPM
   * UPC                                  * GIF
   * CodeABar                             * PCX
   * Code 128                             * PBM
   * Code 3/9                             * LaTeX
   * Code 2/5                             * Postscript
   * Code 2/5 Matrix
   * Code 2/5 Interleaved

Falls Sie weitere Grafikformate benoetigen haben Sie zwei Moeglichkeiten:

  1.  Ueberweisen Sie eine Million D-Mark auf unsere Lichtensteiner-
      Konten und kontaktieren Sie uns.

  2.  Geben Sie "man 5 ppm" ein, durchlesen!
      Unter "SEE ALSO" ist eine Reihe von Konvertierungsprogrammen
      aufgefuehrt (ppmto***) die das Format PPM umwandeln koennen.
      Aufruf dieser Programme:  z.b. PPM zu XPM kovertieren

      ppmtoxpm < IHRE_BILD_DATEI_IM_PPM_FORMAT > AUSGABE_DATEI_IM_XPM_FORMAT

Hinweise zu den Rollbalken:

* Wenn Sie Rastergrafikdateien erzeugen moechten, koennen Sie nur die Hoehe
  (in Pixeln) des erzeugten Strichcodes festlegen.
* Bei LaTeX- oder Postscript-Dateien koennen Sie Breite und Hoehe des Strich-
  codes einstellen.  Die Masseinheit ist dabei, wie in Postscript ueblich:
  1/72 Zoll (ca. 0.35mm)

Fuer eventuelle Anregungen und Geldspenden stehen wir jederzeit zur
Verfuegung ( ..... besonders bei Geldspenden .... )


Martin Bauer          Jan Laitenberger
Zeppelinstr. 97       Hauptmannsreute 166
70193 Stuttgart       70193 Stuttgart
Tel. 0711 6362008


..... fuer kleine (und auch grosse) Geldspenden immer dankbar ....

KONTO: 1092034600  INHABER: Martin Bauer
BLZ  :   60020030  BANK   : BW-Bank Stuttgart

*****************************************************************************/
bool Post::Code39(char* CharText_, char* CodeText)
{
  bool Result;
  char CharText[256];
  char Code[44][13];
  long t, Nr, FORLIM;

  strcpy(CharText, CharText_);
  strcpy(Code[0], "101001101101");   /* 0..  */
  strcpy(Code[1], "110100101011");
  strcpy(Code[2], "101100101011");
  strcpy(Code[3], "110110010101");
  strcpy(Code[4], "101001101011");
  strcpy(Code[5], "110100110101");
  strcpy(Code[6], "101100110101");
  strcpy(Code[7], "101001011011");
  strcpy(Code[8], "110100101101");
  strcpy(Code[9], "101100101101");   /* .. 9 */
  strcpy(Code[10], "110101001011");   /* A .. */
  strcpy(Code[11], "101101001011");
  strcpy(Code[12], "110110100101");
  strcpy(Code[13], "101011001011");
  strcpy(Code[14], "110101100101");
  strcpy(Code[15], "101101100101");
  strcpy(Code[16], "101010011011");
  strcpy(Code[17], "110101001101");
  strcpy(Code[18], "101101001101");
  strcpy(Code[19], "101011001101");   /* .. J */
  strcpy(Code[20], "100100100101");   /* $ */
  strcpy(Code[21], "100100101001");   /* / */
  strcpy(Code[22], "110101010011");   /* K .. */
  strcpy(Code[23], "101101010011");
  strcpy(Code[24], "110110101001");
  strcpy(Code[25], "101011010011");
  strcpy(Code[26], "110101101001");
  strcpy(Code[27], "101101101001");
  strcpy(Code[28], "101010110011");
  strcpy(Code[29], "110101011001");
  strcpy(Code[30], "101101011001");   /* S */
  strcpy(Code[31], "101011011001");
  strcpy(Code[32], "110010101011");
  strcpy(Code[33], "100110101011");
  strcpy(Code[34], "110011010101");
  strcpy(Code[35], "100101101011");
  strcpy(Code[36], "110010110101");
  strcpy(Code[37], "100110110101");   /* .. Z */
  strcpy(Code[38], "100101011011");   /* - */
  strcpy(Code[39], "100101001001");   /* + */
  strcpy(Code[40], "101001001001");   /* % */
  strcpy(Code[41], "110010101101");   /* . */
  strcpy(Code[42], "100110101101");   /* Space */
  strcpy(Code[43], "100101101101");   /* * */ /*(START/STOP)*/
  Result = true;
  strcpy(CodeText,"");
/*  strcpy(CodeText, "1001011011010"); */
  FORLIM = strlen(CharText);
  for (t = 0; t < FORLIM; t++) {
    CharText[t] = toupper(CharText[t]);
    switch (CharText[t]) {

    case '-':
      Nr = 38;
      break;

    case '$':
      Nr = 20;
      break;

    case '/':
      Nr = 21;
      break;

    case '%':
      Nr = 40;
      break;

    case '+':
      Nr = 39;
      break;

    case ' ':
      Nr = 42;
      break;

    case '*':
      Nr = 43;
      break;

    case '.':
      Nr = 41;
      break;

    default:
      if (isdigit(CharText[t]))
        Nr = CharText[t] - '0';
      else if (CharText[t] >= 'A' && CharText[t] <= 'J')
        Nr = CharText[t] - 'A' + 10;
      else if (CharText[t] >= 'K' && CharText[t] <= 'Z')
        Nr = CharText[t] - 'K' + 22;
      else {
        *CodeText = '\0';
        return false;
      }
      break;
    }
    sprintf(CodeText + strlen(CodeText), "%s0", Code[Nr]);
  }
/*  strcat(CodeText, "100101101101"); */
  return Result;
}

void Post::CreateBar(wxFile* fd, char* text, double x, double y, double size ) 
{
	char codeText[1024];
	char* CodeText;
	double pos;
	int i;
	wxString str;
	if (!Code39(text,codeText)) { return; }
	CodeText = codeText;
	for ( pos=0; *CodeText!=0 ; ) {
		for (i=0; *CodeText!='0' && *CodeText!=0 ; i++){
			CodeText++;
		}
		pos = pos + (i/40.0) * size;
		str.Printf("%.2f slw ",(i/20.0) * size);
		fd->Write(str);
		str.Printf("%.2f %.2f mv ",x+pos,y-(size/5));
		fd->Write(str);
		str.Printf("0 %.2f rls\n", size * 0.75);
		fd->Write(str);
		pos = pos + (i/40.0) * size;
		for (i=0; *CodeText!='1' && *CodeText!=0 ;i++) {
			CodeText++;
		}
		pos = pos + (i/20.0) * size;
	}
}
