#include "wx/wxprec.h"

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif
#include "wx/notebook.h"
#include "logo.xpm"
#include "wx/statbmp.h"
#include <wx/filedlg.h>
#include "wx/log.h"
#include "wx/config.h"
#include "post.h"

#include "mypanel.h"
#include "doclabel.h"
//----------------------------------------------------------------------
// class definitions
//----------------------------------------------------------------------

class MyApp: public wxApp
{
public:
    	bool OnInit();
	int OnExit();
};



class MyFrame: public wxFrame
{
public:
    	MyFrame(wxFrame *frame, char *title, int x, int y, int w, int h);

    	void OnQuit(wxCommandEvent& event);

private:
    	DECLARE_EVENT_TABLE()
};

//----------------------------------------------------------------------
// main()
//----------------------------------------------------------------------

IMPLEMENT_APP(MyApp)

//----------------------------------------------------------------------
// MyApp
//----------------------------------------------------------------------
enum
{
	MENU_QUIT = 100
};

bool MyApp::OnInit()
{
	// ID
	SetVendorName("OksiD");
	SetAppName("test");

    	// Create the main frame window
    	MyFrame *frame = new MyFrame((wxFrame *) NULL,
            	"Etiquettes",
            	50, 50, 530, 420);

	wxMenu *file_menu = new wxMenu;
	file_menu->Append(MENU_QUIT, "E&xit");
	wxMenuBar *menu_bar = new wxMenuBar;
	menu_bar->Append(file_menu, "&File");
	
	frame->SetMenuBar(menu_bar);
	frame->Show(TRUE);
	frame->SetCursor(wxCursor(wxCURSOR_HAND));
	SetTopWindow(frame);
	return TRUE;
}

int MyApp::OnExit()
{
	delete wxConfigBase::Set((wxConfigBase *) NULL);
	return 0;
}

//----------------------------------------------------------------------
// MyPanel
//----------------------------------------------------------------------
wxString MyPanel::font_type[] =
{
        "Courier-Bold",
        "Courier",
        "Helvetica-Bold",
        "Helvetica",
        "Times-Bold",
        "Times-Roman",
        "Times-BoldItalic",
        "Times-Italic",
        "Code-Barre"
};
wxString MyPanel::font_size[] =
{
        "6","7","8","9","10","12","14","16","18","24","30","34","40"
};
wxString MyPanel::font_align[] =
{
        "gauche",
        "centre",
        "droite"
};
wxString MyPanel::nb_type[] =
{
	"Dcimal",
	"Hexadcimal"
};
const int  ID_NOTEBOOK          = 1000;
const int  ID_FRAME1		= 1001;
const int  ID_FRAME2		= 1002;
const int  ID_FONT		= 1003;
const int  ID_BIT_ALIGN		= 1004;
const int  ID_BIT_LINE		= 1005;
const int  ID_BIT_SELECT	= 1006;
const int  ID_FILE_SAVE		= 1007;
const int  ID_FILE_OPEN		= 1008;
const int  ID_PRINT		= 1009;
const int  ID_PRINT_PREVIEW	= 1010;

BEGIN_EVENT_TABLE(MyPanel, wxPanel)
EVT_BUTTON(ID_BIT_SELECT,	MyPanel::OnBitmapSelect)
EVT_BUTTON(ID_FILE_SAVE,	MyPanel::OnFileSave)
EVT_BUTTON(ID_FILE_OPEN,	MyPanel::OnFileOpen)
EVT_BUTTON(ID_PRINT,		MyPanel::OnPrint)
EVT_BUTTON(ID_PRINT_PREVIEW,    MyPanel::OnPrintPreview)
END_EVENT_TABLE()
MyPanel::MyPanel( wxFrame *frame, int x, int y, int w, int h )
: wxPanel( frame, -1, wxPoint(x, y), wxSize(w, h) )
{
	m_notebook = new wxNotebook( this, ID_NOTEBOOK, wxPoint(0,0),
			 wxSize(525,385) );
	wxPanel *panel = (wxPanel*) NULL;
		
	// first panel
	int x,y;
	x = 10;
	y = 10;
	panel = new wxPanel(m_notebook);
	for(int i=0;i<5;i++) {
		m_txt[i] = new wxTextCtrl( panel, ID_FRAME1, "", 
				wxPoint(x, y + i*30), wxSize(300,28));
		m_txt_size[i] = new wxComboBox( panel, ID_FRAME1,"", 
				wxPoint(x+302, y + i*30), wxSize(45,28),
				WXSIZEOF(font_size), font_size );
		m_txt_font[i] = new wxChoice( panel, ID_FRAME1,
				wxPoint(x+349, y + i*30), wxSize(80,28),
				WXSIZEOF(font_type), font_type );	
		m_txt_align[i] = new wxChoice( panel, ID_FRAME1,
                                wxPoint(x+430, y + i*30), wxSize(70,28),
                                WXSIZEOF(font_align), font_align );	
	}
	y = 160 + 5;
	x = 10;
	for(int i=0;i<5;i++) {
                m_txt[i+5] = new wxTextCtrl( panel, ID_FRAME1, "",
                                wxPoint(x, y + i*30), wxSize(300,28));
		m_txt_size[i+5] = new wxComboBox( panel, ID_FRAME1,"",
                                wxPoint(x+302, y + i*30), wxSize(45,28),
                                WXSIZEOF(font_size), font_size );
                m_txt_font[i+5] = new wxChoice( panel, ID_FONT,
                                wxPoint(x+349, y + i*30), wxSize(80,28),
                                WXSIZEOF(font_type), font_type );
		m_txt_align[i+5] = new wxChoice( panel, ID_FRAME1,
                                wxPoint(x+430, y + i*30), wxSize(70,28),
                                WXSIZEOF(font_align), font_align );
        }

	m_notebook->AddPage(panel, "Entre Texte", FALSE, -1);
		
	//second panel
	wxString pos[] =
	{
		"","","",
		"","","",
		"","",""
	};
	panel = new wxPanel(m_notebook);
	wxBitmap bi(logo_xpm);
        m_bitmap = new wxStaticBitmap(panel, ID_FRAME1, bi ,
                        wxPoint(10, 20));
	m_bit_align = new wxRadioBox( panel, ID_BIT_ALIGN, 
			"Position", 
			wxPoint(80,10), wxSize(-1,-1), 
			WXSIZEOF(pos), 
			pos, 3, wxRA_SPECIFY_COLS );
 	m_bit_ligne = new wxCheckBox( panel, ID_BIT_LINE, 
			"ligne de sparation au milieu",
			 wxPoint(170,50), wxSize(-1,-1) );
	m_bit_ligne->SetValue(FALSE);
	(void)new wxButton( panel, ID_BIT_SELECT, "choix de l'image",
		 wxPoint(400,20), wxSize(-1,-1));
	m_bit_txt = new wxTextCtrl( panel, ID_FRAME1, "",
                                wxPoint(170,20), wxSize(210,28));
	m_notebook->AddPage(panel, "image Logo", FALSE, -1);
	
	//THIRD panel
	panel = new wxPanel(m_notebook);
	//get paper format
	wxConfigBase *pConfig = wxConfigBase::Get();
	long nb = pConfig->Read("Paper/Nb",(long) 0);
	// pConfig->Write("/Controls/T", (long) 100);
	wxString str;
	wxString pap[nb];
	m_paper = new struct PostLabel[nb]; 
	for (long i=0; i<nb;i++) {
		str.Printf("Paper/%d/name",i);
		pap[i] =  m_paper[i].name = pConfig->Read( str.GetData(),"");
		str.Printf("Paper/%d/w",i);
		m_paper[i].w = pConfig->Read( str.GetData(),(double) 0);
		str.Printf("Paper/%d/h",i);
		m_paper[i].h = pConfig->Read( str.GetData(),(double) 0);
		str.Printf("Paper/%d/m_l",i);
		m_paper[i].m_l = pConfig->Read( str.GetData(),(double) 0);
		str.Printf("Paper/%d/m_u",i);
		m_paper[i].m_u = pConfig->Read( str.GetData(),(double) 0);
		str.Printf("Paper/%d/nb_col",i);
		m_paper[i].nb_col = (int)pConfig->Read( str.GetData(),(long) 0);
		str.Printf("Paper/%d/nb_row",i);
		m_paper[i].nb_row = (int)pConfig->Read( str.GetData(),(long) 0);
		str.Printf("Paper/%d/l_w",i);
		m_paper[i].l_w = pConfig->Read( str.GetData(),(double) 0);
		str.Printf("Paper/%d/l_h",i);
		m_paper[i].l_h = pConfig->Read( str.GetData(),(double) 0);
		str.Printf("Paper/%d/l_x",i);
		m_paper[i].l_x = pConfig->Read( str.GetData(),(double) 0);
		str.Printf("Paper/%d/l_y",i);
		m_paper[i].l_y = pConfig->Read( str.GetData(),(double) 0);
	}
	
	(void)new wxStaticText( panel, -1,
		"Type de papier",
		wxPoint(30, 10), wxSize(-1,-1));
	(void)new wxButton( panel, ID_PRINT_PREVIEW, "Prvisualiser",
                 wxPoint(315,30), wxSize(-1,-1));
	(void)new wxButton( panel, ID_PRINT, "Imprimer",
                 wxPoint(315,60), wxSize(-1,-1));

	m_paper_type = new wxChoice( panel, ID_FRAME1,
                                wxPoint(30, 30), wxSize(120,28),
                                nb, pap );
	m_file = new wxTextCtrl( panel, ID_FRAME1, "",
                                wxPoint(10,130), wxSize(300,28));
	(void)new wxButton( panel, ID_FILE_OPEN, "Ouvrir",
                 wxPoint(315,130), wxSize(-1,-1));
	(void)new wxButton( panel, ID_FILE_SAVE, "Sauver",
                 wxPoint(315,160), wxSize(-1,-1));

	m_notebook->AddPage(panel, "Fichier", FALSE, -1);

	//fourth panel
	 panel = new wxPanel(m_notebook);
	 (void)new wxStaticText( panel, -1,
                "De :",
                wxPoint(10, 10), wxSize(-1,-1));
	m_nb_from =  new wxTextCtrl( panel, ID_FRAME1, "",
                                wxPoint(60,10), wxSize(100,28));
/*
	(void)new wxStaticText( panel, -1,
                " :",
                wxPoint(10, 40), wxSize(-1,-1));

	m_nb_to =  new wxTextCtrl( panel, ID_FRAME1, "",
                                wxPoint(60,40), wxSize(100,28));
	m_nb_type = new wxChoice( panel, ID_FRAME1,
                                wxPoint(200, 28), wxSize(120,28),
                                WXSIZEOF(nb_type), nb_type);
*/
	m_notebook->AddPage(panel, "gnrateur de nombres", FALSE, -1);

}

void MyPanel::OnFileOpen(wxCommandEvent &event )
{
	DocLabel doc(this);
        wxFileDialog dialog(this,
		"Ouvrir un document",
	"", "", "*", 0);
	 if (dialog.ShowModal() == wxID_OK)
        {
                m_file->SetValue(dialog.GetPath().c_str());
		doc.Open();
        }
}

void MyPanel::OnFileSave(wxCommandEvent &event )
{

	DocLabel doc(this);
        wxFileDialog dialog(this,
                "Sauver un document",
        	 "","",
	 	"label (*.lab)|*.lab",  wxSAVE|wxOVERWRITE_PROMPT);
        if (dialog.ShowModal() == wxID_OK)
        {
                m_file->SetValue(dialog.GetPath().c_str());
		doc.Save();
        }
}

void MyPanel::OnPrintPreview(wxCommandEvent &event ) {
	Post* po = new Post(new wxString("tmp.ps"));
	if (po->CreateFromMyPanel(this))
	{
		system("gv -scale 4 -geometry 500x400 tmp.ps&");
	}
}
void MyPanel::OnPrint(wxCommandEvent &event ) {

}


void MyPanel::OnBitmapSelect(wxCommandEvent &event )
{
	wxFileDialog dialog(this, 
		"Choisir une image", 
		"", "", "*.xpm", 0);
	if (dialog.ShowModal() == wxID_OK)
        {
		m_bit_txt->SetValue(dialog.GetPath().c_str());
	}	
}

MyPanel::~MyPanel()
{
}
//----------------------------------------------------------------------
// MyFrame
//----------------------------------------------------------------------

BEGIN_EVENT_TABLE(MyFrame, wxFrame)
EVT_MENU(MENU_QUIT,   MyFrame::OnQuit)
END_EVENT_TABLE()

MyFrame::MyFrame(wxFrame *frame, char *title, int x, int y, int w, int h)
: wxFrame(frame, -1, title, wxPoint(x, y), wxSize(w, h))
{
    (void)new MyPanel( this, 10, 10, 300, 100 );
}

void MyFrame::OnQuit (wxCommandEvent& WXUNUSED(event) )
{
    Close(TRUE);
}

